/*
 * plcsrvthread.cpp
 *
 *	10.04.06 - GZS: first release  
 *
 *
 */

#include "plcsrvthread.h"
#include "plclgthread.h"
#include <iomanip>      //used for debug dump of db

namespace PLCesall_ns{

/* 
 *	plcsrvthread::run()
 *	Run  
 */		
void plcsrvthread::run(void *)
{
	
	int pausemicro = 3000000;
	server_started=0;
	
	buf = new char[2*BUF_LEN];
	while (!t_PLCesall->abortflag) { 
	
		if(server_started==0)
			Srv_Prepare(); 
		else
   			t_PLCesall->set_state(Tango::FAULT);
			t_PLCesall->set_status("srv not connected");
		
		usleep(pausemicro);	
		DEBUG_STREAM << "plcsrvthread::run() trying to reconnect" << endl;
	}
	delete [] buf;
}




void plcsrvthread::Srv_Prepare(void)
{
	bool rcv_stat = false;
	bool rcv_alm = false;
	bool rcv_out = false;
	bool rcv_real = false;
	char *save_buf_ptr;
	//creating server socket
	if (( t_PLCesall->sock = socket(AF_INET, SOCK_STREAM, 0)) < 0 ) {
		server_started=0;
		t_PLCesall->set_state(Tango::FAULT);
		t_PLCesall->set_status("srv sock creating failure");
		t_PLCesall->plc_status = false;
		DEBUG_STREAM << "plcsrvthread::Srv_Prepare() srv sock creating failure" << endl;
		return;
	}
	DEBUG_STREAM << "plcsrvthread::Srv_Prepare() sock ok"<<endl;
	myname.sin_family = AF_INET;  
	myname.sin_port = htons(t_PLCesall->pport);  /// Pport=server port
	myname.sin_addr.s_addr = inet_addr(t_PLCesall->srv_host.c_str());

	struct linger sock_linger;
	sock_linger.l_onoff = 1;/* linger active */
	sock_linger.l_linger = 0;/* how many seconds to linger for */

	setsockopt(t_PLCesall->sock, SOL_SOCKET, SO_LINGER,&sock_linger, sizeof(sock_linger));
	 
	if (bind(t_PLCesall->sock, (const sockaddr*)&myname, sizeof(myname) ) < 0 ) 
	{
		close (t_PLCesall->sock);
		t_PLCesall->sock = -1;
		server_started=0;
		t_PLCesall->set_state(Tango::FAULT);
		t_PLCesall->set_status("srv sock bind failure");
		t_PLCesall->plc_status = false;
		DEBUG_STREAM << "plcsrvthread::Srv_Prepare() srv sock bind failure" << endl;
		return;
	}
	
	DEBUG_STREAM << "plcsrvthread::Srv_Prepare() bind ok"<<endl;
	//server socket listening
	
   	if ( listen ( t_PLCesall->sock, MAX_NUM_SOCK ) < 0 )
   	{ 
		close (t_PLCesall->sock);
		t_PLCesall->sock = -1;
		server_started=0;
   		t_PLCesall->set_state(Tango::FAULT);
		t_PLCesall->set_status("srv sock listen failure");
		t_PLCesall->plc_status = false;
		DEBUG_STREAM << "plcsrvthread::Srv_Prepare() srv sock listen failure" << endl;
		return;
   	}
	DEBUG_STREAM << "plcsrvthread::Srv_Prepare() listen ok"<<endl;
	
	while (!t_PLCesall->abortflag) 
	{ 
		int adrlen = sizeof(struct sockaddr);	
		server_started=1; //the server is listening
		//assign the accepted socket to new_sd
	
    	if ( ( t_PLCesall->new_sd = accept ( t_PLCesall->sock, (sockaddr*)&addr, (socklen_t*)&adrlen ) ) < 0 )
    	{
   			t_PLCesall->set_state(Tango::FAULT);
			t_PLCesall->set_status("srv sock accept failure");
			t_PLCesall->plc_status = false;
			DEBUG_STREAM << "plcsrvthread::Srv_Prepare() srv sock accept failure" << endl;
      	}
		else
		{//connection established
			DEBUG_STREAM << "plcsrvthread::Srv_Prepare() accept ok"<<endl;
			usleep(100000);
			try {
				memset(&t_PLCesall->prepared_cmd, 0, sizeof(intlck_cmd));
				t_PLCesall->prepared_cmd.actDB = ECHO_MESG_STAT_SYS_CMD;
				t_PLCesall->write_msg();
			} catch(...)
			{
			
			}

//  		int counter = 0;//number of read counter
			errcount =0;
			first_mesg = true;
        	do 
        	{
            	memset (buf,0,2*BUF_LEN);
//usleep(10000000);

         		// read message from remote client
       			if (( cnt = read (t_PLCesall->new_sd, buf, BUF_LEN)) < 0 )
       			{
					t_PLCesall->set_state(Tango::FAULT);
					t_PLCesall->set_status("read failed");
					t_PLCesall->plc_status = false;
					//DEBUG_STREAM << "plcsrvthread::Srv_Prepare() read failed" << endl;
					DEBUG_STREAM << "plcsrvthread::Srv_Prepare() read failed: "<<strerror(errno)<<endl;
					break; 
            	}
            	else if (cnt == 0) 
            	{
				//now saving the old timestamp before overwriting
/*					t_PLCesall->old_tst_stat.year = (u_short)(t_PLCesall->message_stat.year);
					t_PLCesall->old_tst_stat.month = (u_short)(t_PLCesall->message_stat.month);
					t_PLCesall->old_tst_stat.day = (u_short)(t_PLCesall->message_stat.day);
					t_PLCesall->old_tst_stat.hour = (u_short)(t_PLCesall->message_stat.hour);
					t_PLCesall->old_tst_stat.min = (u_short)(t_PLCesall->message_stat.min);
					t_PLCesall->old_tst_stat.sec = (u_short)(t_PLCesall->message_stat.sec);
					t_PLCesall->old_tst_stat.msec = (((u_short)(t_PLCesall->message_stat.msec))<<4)|((((u_short)(t_PLCesall->message_stat.wday))&0x00ff)>>4);
					t_PLCesall->old_tst_stat.wday = ((u_short)(t_PLCesall->message_stat.wday))&0x000f;*/
					DEBUG_STREAM << "plcsrvthread::Srv_Prepare() read 0 char"<<endl;
               		continue; 
            	}
            	else 
            	{ //reading ok
            		save_buf_ptr = &buf[0];
					while(cnt > 0)
					{
						//INFO_STREAM << "plcsrvthread::Srv_Prepare() message read, len: " << cnt << endl;
						/*for(int k=0;k<cnt;)
						{
							stringstream tmp;
							int g;
							tmp << "db: "<<setw(3)<<setfill(' ')<<k<<" -> ";
							for(g=0; g<10; g++)
							{
								if(k+g>=cnt)
									break;
								tmp << " " <<hex<<setw(2)<<setfill(' ')<< (int)buf[k+g];
							}
							k+=g;
							if(k<cnt)
							{
								tmp << " |  "<<dec<<setw(3)<<setfill(' ')<<k<<hex<<" -> ";
								for(g=0; g<10; g++)
								{
									if(k+g>=cnt)
										break;
									tmp << " " <<hex<<setw(2)<<setfill(' ')<< (int)buf[k+g];
								}
								k+=g;
							}
							DEBUG_STREAM<<tmp.str()<<dec<<endl;
						}*/

						//int btype = (int)buf[1];
						short *type = (short *)&buf[0];
						short btype = ntohs(*type);
//						if((int)buf[3]==33)btype = 121;
//						if((int)buf[3]==34)btype = 122;
//						cout << "plcsrvthread::run() received type:" << btype <<" length:"<< cnt<<endl;
						switch(btype)
						{	
							case 53:
							{
								t_PLCesall->plc_status = true;
								while(cnt < sizeof(PLCesall_ns::intlck_dbalmsys))
								{
									DEBUG_STREAM << "db53: read "<<cnt<<" but size of struct="<< sizeof(PLCesall_ns::intlck_dbalmsys)<< endl;
									// read message from remote client
									int cnt2;
									if (( cnt2 = read (t_PLCesall->new_sd, &buf[cnt], sizeof(PLCesall_ns::intlck_dbalmsys)-cnt)) < 0 ) 
									{
										//mydevice->set_state(Tango::FAULT);
										if(t_PLCesall->get_state() != Tango::FAULT)
										{
											Tango::DevState st = Tango::FAULT;
											t_PLCesall->set_state(st);	
											try {
												t_PLCesall->push_change_event("state", &st);
											} catch(Tango::DevFailed &e)
											{
												INFO_STREAM << "readthread::Srv_Prepare() error pushing state="<<e.errors[0].desc<<endl;
											}
										}
										t_PLCesall->set_status("read failed");
										t_PLCesall->plc_status = false;
										DEBUG_STREAM<<"readthread::Srv_Prepare() read2 failed: "<<strerror(errno)<<endl;
										break;
									}
									cnt+=cnt2;
								}
								DEBUG_STREAM << "db53: finally read "<<cnt<< endl;
								if(cnt >= sizeof(PLCesall_ns::intlck_dbalmsys))
								{
									alm_msg();
									t_PLCesall->attr_Alarm_system_read = &t_PLCesall->msg_almsys[0];
									//attr.set_value(attr_Alarm_system_read, MESG_ALM_SYS_LEN, 0, false);
									t_PLCesall->push_change_event("Alarm_system", t_PLCesall->attr_Alarm_system_read, MESG_ALM_SYS_LEN);
		
									timeval time;
									/*double fractpart, intpart;
							
									fractpart = modf (t_PLCesall->timestamp_alm , &intpart);
									time.tv_sec = (__time_t)intpart;
									time.tv_usec = (__suseconds_t)fractpart*1000000;*/
									gettimeofday(&time, NULL);
									t_PLCesall->attr_Db_alarm_read = &t_PLCesall->alarm_db[0];	
									t_PLCesall->push_change_event("Db_alarm", t_PLCesall->attr_Db_alarm_read, time, Tango::ATTR_VALID, MESG_ALM_SYS_LEN);
									cnt -= sizeof(PLCesall_ns::intlck_dbalmsys);
									buf = &buf[sizeof(PLCesall_ns::intlck_dbalmsys)];
									rcv_alm=true;
								}
								else
								{
									INFO_STREAM << "plcsrvthread::Srv_Prepare() ERROR: db"<<btype<<" BAD len: " << cnt << endl;
									cnt = 0;
								}
								if(!rcv_stat)
								{
									usleep(100000);
									try {
										memset(&t_PLCesall->prepared_cmd, 0, sizeof(intlck_cmd));
										t_PLCesall->prepared_cmd.actDB = ECHO_MESG_STAT_SYS_CMD;
										t_PLCesall->write_msg();
									} catch(...)
									{
									
									}
								}
								break;
							}
							case 50:
								t_PLCesall->plc_status = true;
								DEBUG_STREAM << "########## db50 ##########" << endl;
								while(cnt < sizeof(PLCesall_ns::intlck_dbstatsys))
								{
									DEBUG_STREAM << "db50: read "<<cnt<<" but size of struct="<< sizeof(PLCesall_ns::intlck_dbstatsys)<< endl;
									// read message from remote client
									int cnt2;
									if (( cnt2 = read (t_PLCesall->new_sd, &buf[cnt], sizeof(PLCesall_ns::intlck_dbstatsys)-cnt)) < 0 ) 
									{
										//mydevice->set_state(Tango::FAULT);
										if(t_PLCesall->get_state() != Tango::FAULT)
										{
											Tango::DevState st = Tango::FAULT;
											t_PLCesall->set_state(st);	
											try {
												t_PLCesall->push_change_event("state", &st);
											} catch(Tango::DevFailed &e)
											{
												INFO_STREAM << "readthread::Srv_Prepare() error pushing state="<<e.errors[0].desc<<endl;
											}
										}
										t_PLCesall->set_status("read failed");
										t_PLCesall->plc_status = false;
										DEBUG_STREAM << "readthread::Srv_Prepare() read2 failed" << endl;
										DEBUG_STREAM<<"read2 failed: "<<strerror(errno)<<endl;
										break;
									}
									cnt+=cnt2;
								}
								DEBUG_STREAM << "db50: finally read "<<cnt<< endl;
								if(cnt >= sizeof(PLCesall_ns::intlck_dbstatsys))
								{
									stat_msg();
									t_PLCesall->attr_Stat_system_read = &t_PLCesall->msg_statsys[0];
									t_PLCesall->push_change_event("Stat_system", t_PLCesall->attr_Stat_system_read, MESG_STAT_SYS_LEN);
									cnt -= sizeof(PLCesall_ns::intlck_dbstatsys);
									buf = &buf[sizeof(PLCesall_ns::intlck_dbstatsys)];
									rcv_stat=true;
								}
								else
								{
									INFO_STREAM << "plcsrvthread::Srv_Prepare() ERROR: db"<<btype<<" BAD len: " << cnt << endl;
									cnt = 0;								
								}
								if(!rcv_alm)
								{
									usleep(100000);
									try {
										memset(&t_PLCesall->prepared_cmd, 0, sizeof(intlck_cmd));
										t_PLCesall->prepared_cmd.actDB = ECHO_MESG_ALM_SYS_CMD;
										t_PLCesall->write_msg();
									} catch(...)
									{
									
									}
								}
								break;
							case 54:
								t_PLCesall->plc_status = true;
								if(cnt >= sizeof(PLCesall_ns::intlck_dboutsys))
								{
									out_msg();
									cnt -= sizeof(PLCesall_ns::intlck_dboutsys);
									buf = &buf[sizeof(PLCesall_ns::intlck_dboutsys)];
									rcv_out=true;
								}
								else
								{
									INFO_STREAM << "plcsrvthread::Srv_Prepare() ERROR: db"<<btype<<" BAD len: " << cnt << endl;
									cnt = 0;
								}
								if(!rcv_stat)
								{
									usleep(100000);
									try {
										memset(&t_PLCesall->prepared_cmd, 0, sizeof(intlck_cmd));
										t_PLCesall->prepared_cmd.actDB = ECHO_MESG_STAT_SYS_CMD;
										t_PLCesall->write_msg();
									} catch(...)
									{
									
									}
								}		
								break;
							case 55:
							{
								t_PLCesall->plc_status = true;
								DEBUG_STREAM << "########## db55 ##########" << endl;
								while(cnt < sizeof(PLCesall_ns::intlck_dbrealsys))
								{
									DEBUG_STREAM << "db55: read "<<cnt<<" but size of struct="<< sizeof(PLCesall_ns::intlck_dbstatsys)<< endl;
									// read message from remote client
									int cnt2;
									if (( cnt2 = read (t_PLCesall->new_sd, &buf[cnt], sizeof(PLCesall_ns::intlck_dbrealsys)-cnt)) < 0 ) 
									{
										//mydevice->set_state(Tango::FAULT);
										if(t_PLCesall->get_state() != Tango::FAULT)
										{
											Tango::DevState st = Tango::FAULT;
											t_PLCesall->set_state(st);	
											try {
												t_PLCesall->push_change_event("state", &st);
											} catch(Tango::DevFailed &e)
											{
												INFO_STREAM << "readthread::Srv_Prepare() error pushing state="<<e.errors[0].desc<<endl;
											}
										}
										t_PLCesall->set_status("read failed");
										t_PLCesall->plc_status = false;
										DEBUG_STREAM << "readthread::Srv_Prepare() read2 failed" << endl;
										DEBUG_STREAM<<"read2 failed: "<<strerror(errno)<<endl;
										break;
									}
									cnt+=cnt2;
								}
								DEBUG_STREAM << "db55: finally read "<<cnt<< endl;
								if(cnt >= sizeof(PLCesall_ns::intlck_dbrealsys))
								{
									real_msg();
									for(int i=0; i<MESG_REAL_SYS_LEN; i++)
										t_PLCesall->attr_Real_system_read[i] = t_PLCesall->msg_realsys[i];
									t_PLCesall->push_change_event("Real_system", t_PLCesall->attr_Real_system_read, MESG_REAL_SYS_LEN);
									cnt -= sizeof(PLCesall_ns::intlck_dbrealsys);
									buf = &buf[sizeof(PLCesall_ns::intlck_dbrealsys)];
									rcv_real=true;
								}
								else
								{
									INFO_STREAM << "plcsrvthread::Srv_Prepare() ERROR: db"<<btype<<" BAD len: " << cnt << endl;
									cnt = 0;
								}
								if(!rcv_stat)
								{
									usleep(100000);
									try {
										memset(&t_PLCesall->prepared_cmd, 0, sizeof(intlck_cmd));
										t_PLCesall->prepared_cmd.actDB = ECHO_MESG_STAT_SYS_CMD;
										t_PLCesall->write_msg();
									} catch(...)
									{
									
									}
								}
								if(!rcv_alm)
								{
									usleep(100000);
									try {
										memset(&t_PLCesall->prepared_cmd, 0, sizeof(intlck_cmd));
										t_PLCesall->prepared_cmd.actDB = ECHO_MESG_ALM_SYS_CMD;
										t_PLCesall->write_msg();
									} catch(...)
									{
									
									}
								}
								if(!rcv_out)
								{
									usleep(100000);
									try {
										memset(&t_PLCesall->prepared_cmd, 0, sizeof(intlck_cmd));
										t_PLCesall->prepared_cmd.actDB = ECHO_MESG_OUT_SYS_CMD;
										t_PLCesall->write_msg();
									} catch(...)
									{
									
									}
								}
								break;
							}
							default:				
								INFO_STREAM << "plcsrvthread::Srv_Prepare() message not recognized, type "<<btype<<" len: "<< cnt<< endl;
								errcount++;
								info_msg();
								cnt = 0;
								break;
						}//end of switch
					}//end while(cnt > 0)
					buf = save_buf_ptr;
					cnt = 1;	//not 0 to exit outer loop
            	}  // end of message-print else 
         		 // end of do loop statement 
         	}while ((cnt > 0)&&(!t_PLCesall->abortflag));  // do loop condition 
		}//end of accept else
  	}  // end of while (1) 
	if(t_PLCesall->sock!= -1)
	{
		close(t_PLCesall->sock);
		t_PLCesall->sock = -1;
	}
	
	server_started=0;
	return;
	
}

uint16_t plcsrvthread::plc_swap(uint16_t in)
{
	return ((in>>8)|((in&0x00ff)<<8));
}

void plcsrvthread::info_msg(void)
{
/*	char m[50];
	memset(m, 0, 50);
	sprintf(m, "errcount: %d,lastmsg len:%d", errcount, cnt);
	t_PLCesall->set_status(m);*/
}



void plcsrvthread::stat_msg(void)
{
	cnt2=0;
	t_PLCesall->set_state(Tango::ON);
	t_PLCesall->set_status(" message read");
	INFO_STREAM << "plcsrvthread::stat_msg() db50 read" << endl;
	
//******************************************************rawraw message
	//DEBUG_STREAM << "plcsrvthread::stat_msg() "<<(int)buf[0]<<"-"<<(int)buf[1]<<"-"<<(int)buf[2]<<"-"<<(int)buf[3]<<""<<endl;
/*	for(int k=0;k<cnt;)
	{
		stringstream tmp;
		int g;
		tmp << "db50: "<<setw(3)<<setfill(' ')<<k<<" -> ";
		for(g=0; g<10; g++)
		{
			if(k+g>=cnt)
				break;
			tmp << " " <<hex<<setw(2)<<setfill(' ')<< (unsigned int)buf[k+g];
		}
		k+=g;
		if(k<cnt)
		{
			tmp << " |  "<<dec<<setw(4)<<setfill(' ')<<k<<hex<<" -> ";
			for(g=0; g<10; g++)
			{
				if(k+g>=cnt)
					break;
				tmp << " " <<hex<<setw(2)<<setfill(' ')<< (unsigned int)buf[k+g];
			}
			k+=g;
		}
		DEBUG_STREAM<<tmp.str()<<dec<<endl;
	}*/
	memcpy(&(t_PLCesall->message_statsys), buf, sizeof(PLCesall_ns::intlck_dbstatsys));

	for(int k=0; k<DB50_DATA_SIZE; k++)
	{
		//DEBUG_STREAM << "stat_msg: j="<<j<<" k="<<k<<" message_statsys.shot[j].stat[k]="<<hex<<(unsigned int)t_PLCesall->message_statsys.shot[j].stat[k]<<dec;
		for(int i=0;i<8;i++)
		{
			t_PLCesall->msg_statsys[8*k+i] = (((t_PLCesall->message_statsys.data[k])>>i)&0x1)==0?false:true;
		}
	}



	PLCesall_ns::intlck_dbalmsys tmp;

	ll = t_PLCesall->calc_timeval(
						t_PLCesall->message_statsys.year,
						t_PLCesall->message_statsys.month,
						t_PLCesall->message_statsys.day,
						t_PLCesall->message_statsys.hour,
						t_PLCesall->message_statsys.min,
						t_PLCesall->message_statsys.sec,
						t_PLCesall->message_statsys.msec,
						t_PLCesall->message_statsys.wday
						);
		mm = t_PLCesall->calc_time_ms(t_PLCesall->message_statsys.wday,
						t_PLCesall->message_statsys.msec
						);
	
	t_PLCesall->timestamp_stat = ((double)mm)/1000;
	t_PLCesall->timestamp_stat += ll;
	//DEBUG_STREAM << "plcsrvthread::message_almsys() pushing db 50 shot="<<j<<" timestamp="<<fixed<<setprecision(3)<<t_PLCesall->timestamp_stat<<endl;
	
	PLCesall_ns::timest_vect to_log;
	to_log.logtype = L_ALARM_RT;
	to_log.tstamp = t_PLCesall->timestamp_stat;
	memcpy(&(to_log.data), &(t_PLCesall->message_statsys), (sizeof(PLCesall_ns::intlck_dbalmsys)));
	t_PLCesall->logloop->raw_list.push_back(to_log);
}

void plcsrvthread::alm_msg(void)
{
	cnt2=0;
	t_PLCesall->set_state(Tango::ON);
	t_PLCesall->set_status(" message read");
	INFO_STREAM << "plcsrvthread::alm_msg() db53 read" << endl;
	
	
//******************************************************rawraw message (move to acc message)
//	DEBUG_STREAM << "plcsrvthread::alm_msg() "<<(int)buf[0]<<"-"<<(int)buf[1]<<"-"<<(int)buf[2]<<"-"<<(int)buf[3]<<""<<endl;
	for(int k=0;k<cnt;)
	{
		stringstream tmp;
		int g;
		tmp << "db53: "<<setw(3)<<setfill(' ')<<k<<" -> ";
		for(g=0; g<10; g++)
		{
			if(k+g>=cnt)
				break;
			tmp << " " <<hex<<setw(2)<<setfill(' ')<< (unsigned int)buf[k+g];
		}
		k+=g;
		if(k<cnt)
		{
			tmp << " |  "<<dec<<setw(3)<<setfill(' ')<<k<<hex<<" -> ";
			for(g=0; g<10; g++)
			{
				if(k+g>=cnt)
					break;
				tmp << " " <<hex<<setw(2)<<setfill(' ')<< (unsigned int)buf[k+g];
			}
			k+=g;
		}
		DEBUG_STREAM<<tmp.str()<<dec<<endl;
	}
	
	memcpy(&(t_PLCesall->message_almsys), buf, sizeof(PLCesall_ns::intlck_dbalmsys));

	//t_PLCesall->message_almsys.shot.nShot = ntohs(t_PLCesall->message_almsys.shot.nShot);
	//DEBUG_STREAM << "stat_msg: read shot nr=" << t_PLCesall->message_almsys.shot.nShot;
	for(int k=0; k<DB53_DATA_SIZE; k++)
	{
		//DEBUG_STREAM << "stat_msg: k="<<k<<" message_almsys.shot.stat[k]="<<hex<<(unsigned int)t_PLCesall->message_almsys.shot.stat[k]<<dec;
		for(int i=0;i<8;i++)
		{
			//t_PLCesall->msg_statsys[8*k+i] = ((buf[k+10]&bmask[i])>>i)==0?false:true;
			//t_PLCesall->message_statsys.shot.stat[k] = buf[k+10];
			t_PLCesall->msg_almsys[8*k+i] = (((t_PLCesall->message_almsys.data[k])>>i)&0x1)==0?false:true;
			//DEBUG_STREAM << "stat_msg: k="<<k<<" i="<<i<<" buf["<<k+10<<"]="<<hex<<(unsigned int)buf[k+10]<<" message_statsys.shot.stat[k]="<<(unsigned int)t_PLCesall->message_statsys.shot.stat[k]<<dec<<" msg_statsys["<<8*k+i<<"]="<< ((t_PLCesall->msg_statsys[8*k+i])?1:0);
		}
	}	

//	else{//the size is right
	//now saving the old timestamp before overwriting
	t_PLCesall->old_tst_stat.year = (u_char)(t_PLCesall->message_almsys.year);
	t_PLCesall->old_tst_stat.month = (u_char)(t_PLCesall->message_almsys.month);
	t_PLCesall->old_tst_stat.day = (u_char)(t_PLCesall->message_almsys.day);
	t_PLCesall->old_tst_stat.hour = (u_char)(t_PLCesall->message_almsys.hour);
	t_PLCesall->old_tst_stat.min = (u_char)(t_PLCesall->message_almsys.min);
	t_PLCesall->old_tst_stat.sec = (u_char)(t_PLCesall->message_almsys.sec);
	t_PLCesall->old_tst_stat.msec = (((u_char)(t_PLCesall->message_almsys.msec))<<4)|((((u_char)(t_PLCesall->message_almsys.wday))&0x00ff)>>4);
	t_PLCesall->old_tst_stat.wday = ((u_char)(t_PLCesall->message_almsys.wday))&0x000f;

	t_PLCesall->tst_stat.year = (u_char)(t_PLCesall->message_almsys.year);
	t_PLCesall->tst_stat.month = (u_char)(t_PLCesall->message_almsys.month);
	t_PLCesall->tst_stat.day = (u_char)(t_PLCesall->message_almsys.day);
	t_PLCesall->tst_stat.hour = (u_char)(t_PLCesall->message_almsys.hour);
	t_PLCesall->tst_stat.min = (u_char)(t_PLCesall->message_almsys.min);
	t_PLCesall->tst_stat.sec = (u_char)(t_PLCesall->message_almsys.sec);
	t_PLCesall->tst_stat.msec = (((u_char)(t_PLCesall->message_almsys.msec))<<4)|((((u_char)(t_PLCesall->message_almsys.wday))&0x00ff)>>4);
	t_PLCesall->tst_stat.wday = ((u_char)(t_PLCesall->message_almsys.wday))&0x000f;
	
	ll = t_PLCesall->calc_timeval(
						t_PLCesall->message_almsys.year,
						t_PLCesall->message_almsys.month,
						t_PLCesall->message_almsys.day,
						t_PLCesall->message_almsys.hour,
						t_PLCesall->message_almsys.min,
						t_PLCesall->message_almsys.sec,
						t_PLCesall->message_almsys.msec,
						t_PLCesall->message_almsys.wday
						);
		mm = t_PLCesall->calc_time_ms(t_PLCesall->message_almsys.wday,
						t_PLCesall->message_almsys.msec
						);

	t_PLCesall->timestamp_alm = ((double)mm)/1000;
	t_PLCesall->timestamp_alm += ll;
/*	DEBUG_STREAM << "plcsrvthread::alm_msg() pushing db 53 timestamp="<<fixed<<setprecision(3)<<t_PLCesall->timestamp_alm<<endl;
	
	PLCesall_ns::timest_vect to_log;
	to_log.logtype = L_ALARM;
	to_log.tstamp = t_PLCesall->timestamp_alm;
	memcpy(&(to_log.data), &(t_PLCesall->message_almsys), (sizeof(PLCesall_ns::intlck_dbalmsys)));
//	DEBUG_STREAM << "plcsrvthread::alm_msg() pushing db 53 timestamp="<<t_PLCesall->timestamp_alm<<endl;

	t_PLCesall->logloop->raw_list.push_back(to_log);*/
	
	for(int j=0;j<MESG_ALM_SYS_LEN;j++){
		if(t_PLCesall->alm_active[j])
		{
			if(t_PLCesall->msg_almsys[j]){
				t_PLCesall->alarm_db[j] = 0;
				t_PLCesall->old_alm[j] = true;
			}
			else if(t_PLCesall->old_alm[j]){
				t_PLCesall->alarm_db[j] = t_PLCesall->timestamp_alm;
				t_PLCesall->old_alm[j] = false;
				}
		}
	}

}

void plcsrvthread::out_msg(void){
	cnt2=0;
	t_PLCesall->set_state(Tango::ON);
	t_PLCesall->set_status(" message read");
	INFO_STREAM << "plcsrvthread::out_msg() db54 read" << endl;
	
	for(int k=0;k<cnt;)
	{
		stringstream tmp;
		int g;
		tmp << "db54: "<<setw(3)<<setfill(' ')<<k<<" -> ";
		for(g=0; g<10; g++)
		{
			if(k+g>=cnt)
				break;
			tmp << " " <<hex<<setw(2)<<setfill(' ')<< (unsigned int)buf[k+g];
		}
		k+=g;
		if(k<cnt)
		{
			tmp << " |  "<<dec<<setw(3)<<setfill(' ')<<k<<hex<<" -> ";
			for(g=0; g<10; g++)
			{
				if(k+g>=cnt)
					break;
				tmp << " " <<hex<<setw(2)<<setfill(' ')<< (unsigned int)buf[k+g];
			}
			k+=g;
		}
		DEBUG_STREAM<<tmp.str()<<dec<<endl;
	}
	
	memcpy(&(t_PLCesall->message_outsys), buf, sizeof(PLCesall_ns::intlck_dboutsys));

	//t_PLCesall->message_outsys.shot.nShot = ntohs(t_PLCesall->message_outsys.shot.nShot);
	//DEBUG_STREAM << "stat_msg: read shot nr=" << t_PLCesall->message_outsys.shot.nShot;
	for(int k=0; k<DB54_DATA_SIZE; k++)
	{
		//DEBUG_STREAM << "stat_msg: k="<<k<<" message_outsys.shot.stat[k]="<<hex<<(unsigned int)t_PLCesall->message_outsys.shot.stat[k]<<dec;
		for(int i=0;i<8;i++)
		{
			//t_PLCesall->msg_outsys[8*k+i] = ((buf[k+10]&bmask[i])>>i)==0?false:true;
			//t_PLCesall->message_outsys.shot.stat[k] = buf[k+10];
			t_PLCesall->msg_outsys[8*k+i] = (((t_PLCesall->message_outsys.data[k])>>i)&0x1)==0?false:true;
			//DEBUG_STREAM << "stat_msg: k="<<k<<" i="<<i<<" buf["<<k+10<<"]="<<hex<<(unsigned int)buf[k+10]<<" message_outsys.shot.stat[k]="<<(unsigned int)t_PLCesall->message_outsys.shot.stat[k]<<dec<<" msg_outsys["<<8*k+i<<"]="<< ((t_PLCesall->msg_outsys[8*k+i])?1:0);
		}
	}

/*		ll = t_PLCesall->calc_timeval(
						t_PLCesall->message_outsys.month,
						t_PLCesall->message_outsys.year,
						t_PLCesall->message_outsys.hour,
						t_PLCesall->message_outsys.day,
						t_PLCesall->message_outsys.sec,
						t_PLCesall->message_outsys.min,
						t_PLCesall->message_outsys.wday,
						t_PLCesall->message_outsys.msec
						);
		mm = t_PLCesall->calc_time_ms(t_PLCesall->message_outsys.wday,
						t_PLCesall->message_outsys.msec
						);
	
		t_PLCesall->timestamp_last = ((double)mm)/1000;
		t_PLCesall->timestamp_last += ll;
	
*/

}

void plcsrvthread::real_msg(void){
	cnt2=0;
	t_PLCesall->set_state(Tango::ON);
	t_PLCesall->set_status(" message read");
	INFO_STREAM << "plcsrvthread::real_msg() db55 read" << endl;
	
/*	for(int k=0;k<cnt;)
	{
		stringstream tmp;
		int g;
		tmp << "db55: "<<setw(3)<<setfill(' ')<<k<<" -> ";
		for(g=0; g<10; g++)
		{
			if(k+g>=cnt)
				break;
			tmp << " " <<hex<<setw(2)<<setfill(' ')<< (unsigned int)buf[k+g];
		}
		k+=g;
		if(k<cnt)
		{
			tmp << " |  "<<dec<<setw(3)<<setfill(' ')<<k<<hex<<" -> ";
			for(g=0; g<10; g++)
			{
				if(k+g>=cnt)
					break;
				tmp << " " <<hex<<setw(2)<<setfill(' ')<< (unsigned int)buf[k+g];
			}
			k+=g;
		}
		DEBUG_STREAM<<tmp.str()<<dec<<endl;
	}*/
	
	memcpy(&(t_PLCesall->message_realsys), buf, sizeof(PLCesall_ns::intlck_dbrealsys));


	for(int k=0; k<MESG_REAL_SYS_LEN; k++)
	{
		t_PLCesall->msg_realsys[k] = ntohf(t_PLCesall->message_realsys.data[k]);
	}

/*		ll = t_PLCesall->calc_timeval(
						t_PLCesall->message_realsys.month,
						t_PLCesall->message_realsys.year,
						t_PLCesall->message_realsys.hour,
						t_PLCesall->message_realsys.day,
						t_PLCesall->message_realsys.sec,
						t_PLCesall->message_realsys.min,
						t_PLCesall->message_realsys.wday,
						t_PLCesall->message_realsys.msec
						);
		mm = t_PLCesall->calc_time_ms(t_PLCesall->message_realsys.wday,
						t_PLCesall->message_realsys.msec
						);
	
		t_PLCesall->timestamp_last = ((double)mm)/1000;
		t_PLCesall->timestamp_last += ll;
	
*/

}

float plcsrvthread::htonf(float val_f)
{
	float *ret_val;
	uint32_t *val_l;
	uint32_t ret_val_l;
	
	val_l = (uint32_t *)&val_f;
#if 1
	ret_val_l = htonl(*val_l);
#else
# if __BYTE_ORDER == __LITTLE_ENDIAN
	ret_val_l = __bswap_32(*val_l);
#endif
#endif
	ret_val=(float *)&ret_val_l;

	return *ret_val;
}

float plcsrvthread::ntohf(float val_f)
{
	float *ret_val;
	uint32_t *val_l;
	uint32_t ret_val_l;
	
	val_l = (uint32_t *)&val_f;
#if 1
	ret_val_l = ntohl(*val_l);
#else
# if __BYTE_ORDER == __LITTLE_ENDIAN
	ret_val_l = __bswap_32(*val_l);
#endif
#endif
	ret_val=(float *)&ret_val_l;

	return *ret_val;
}

uint32_t plcsrvthread::plc_swaplong(uint32_t in)
{
	return ((in>>16)|((in&0x0000ffff)<<16));
}

}//namespace

